LeetCode 746. 使用最小花费爬楼梯

给你一个整数数组 cost ,其中 cost[i] 是从楼梯第 i 个台阶向上爬需要支付的费用。一旦你支付此费用,即可选择向上爬一个或者两个台阶。

你可以选择从下标为 0 或下标为 1 的台阶开始爬楼梯。

请你计算并返回达到楼梯顶部的最低花费。

示例 1:

复制代码
输入:cost = [10,15,20]
输出:15
解释:你将从下标为 1 的台阶开始。
- 支付 15 ,向上爬两个台阶,到达楼梯顶部。
总花费为 15 。

示例 2:

复制代码
输入:cost = [1,100,1,1,1,100,1,1,100,1]
输出:6
解释:你将从下标为 0 的台阶开始。
- 支付 1 ,向上爬两个台阶,到达下标为 2 的台阶。
- 支付 1 ,向上爬两个台阶,到达下标为 4 的台阶。
- 支付 1 ,向上爬两个台阶,到达下标为 6 的台阶。
- 支付 1 ,向上爬一个台阶,到达下标为 7 的台阶。
- 支付 1 ,向上爬两个台阶,到达下标为 9 的台阶。
- 支付 1 ,向上爬一个台阶,到达楼梯顶部。
总花费为 6 。

提示:

  • 2 <= cost.length <= 1000
  • 0 <= cost[i] <= 999

思路:

本题可采用动态规划解决。

创建一个 dp 数组,dpi 表示跳到第 i 个阶梯需要花费的最少费用。由于 costi 是从第 i 个阶梯往上跳所需要花费的代价,而我们可以选择从第 0 个或者第 1 个阶梯开始起跳,所以 dp0 = 0,dp1 = 0。

确定递推公式:dpi 有两个来源,一是 dpi-1 + costi-1,二是 dpi-2 + costi-2,我们需要选择两者中最小的那一个。然后从前往后遍历即可。

代码:

java 复制代码
class Solution {
    public int minCostClimbingStairs(int[] cost) {
        //dp[i]是到达第i个台阶所需花费的最少费用
        int len = cost.length;
        int[] dp = new int[len+1];
        //到达第0个台阶和第1个台阶都不需要花费
        dp[0] = 0;
        dp[1] = 0;
        //0~len-1 为台阶,len 为楼梯顶部
        for(int i=2;i<=len;i++){
            dp[i]=Math.min(dp[i-1]+cost[i-1],dp[i-2]+cost[i-2]);
        }
        return dp[len];
    }
}

参考:代码随想录

相关推荐
吞下星星的少年·-·几秒前
Div.2 CF 1130B题(构造,贪心)
算法·贪心·构造
文丑颜不良啊3 分钟前
LeetCode1481~1500题目解析
java·leetcode
文丑颜不良啊1 小时前
LeetCode1381~1400题目解析
java·leetcode
是main不是漫1 小时前
【双指针——移动零】数组划分类题目的入门基石
c++·算法
深圳市快瞳科技有限公司2 小时前
野外鸟类AI识别落地实录:输入适配、结构化输出、去重聚合与置信度分流的工程实践
算法·计算机视觉·鸟类识别·鸟类ai识别·野外鸟类观测·林业调查
专注仿真4 小时前
梯度提升类(XFBoost)算法详解与代码实例
开发语言·人工智能·python·算法·大模型训练·控制算法
小豆庄4 小时前
视频遮罩追踪退场后ID撞号的排查—多目标场景下的失效
opencv·算法·bug·视频·python3.11
Tisfy4 小时前
LeetCode 3882.网格图中最小异或路径:动态规划
算法·leetcode·动态规划
D e re k ZH5 小时前
P5025 [SNOI2017] 炸弹
c++·算法
A boy CDEF girl6 小时前
算法题专栏:优选算法
数据结构·算法·leetcode